# PSA1, Python, vezbe


# Matrice i nizovi (Numpy biblioteka, Pylab)
# alternativno: import numpy as np
# Matrice 1

from pylab import *

# Nizovi - skup elemenata istog tipa
# array([]) - funkcija koja kreira niz ili matricu
# Dakle, kreiramo npr. niz:
niz = array([1, 3, 6])
# alternativni nacin importovanja:
# niz2 = np.array([1, 3, 6])
print(niz)
# pristup elementima niza - preko indeksa niz[i]
niz[0]
niz[1]
niz[2]

# Zbir elemenata niza se dobija preko sum():
sum(niz)

# Formiranje Matrice (visedimenzionalni nizovi):
a = array([[1,2], [3,4]])
print(a)
# primetimo da je ovo bas matrica, onakva kakvu ocekujemo, a ne onakva kakvu
# smo dobili preko listi
type(a)

# pristup elementima matrice a[i, j]
a[0, 0]
a[1, 0]
a[0, 1]
a[1, 1]

# prvi red matrice
a[0, :]
# drugi red matrice
a[1, :]
# prva kolona matrice
a[:, 0]
# druga kolona matrice
a[:, 1] 

# Zbir elemenata matrice
sum(a)

# broje elemenata u array
a.size

# oblik: koliko kolona, koliko vrsta, ovde: 2 kolone i 2 vrste
a.shape

# vraca dimenziju niza (iz numpy modula) 
a.ndim
help(ndim)
# moze i preko poziva funkcije, bez OOP
ndim(a)

# tip elemenata niza
a.dtype

# ime tipa elemenata niza
a.dtype.name

# velicina jednog elementa niza u bajtima
a.itemsize
# moze se naci i ukupno zauzece memorije znajuci itemsize i size (broj 
# elemenata u nizu pomnozen sa velicinom jednog elementa u bajtima)



# Matrice - trazenje nekih poznatih parametara matrice
# transponovana matrica
a.transpose()

# a moze i kao poziv funkcije a ne kao OOP
transpose(a)

# determinanta
det(a)

# Eigenvalues and eigenvectors (sopstvene vrednosti i sopstveni vektor mateice)
# module numpy.linalg
eig(a)
b = eig(a)
type(b)

# inverzna matrica
aa = inv(a)
print(aa)
aa.dtype.name



# Matrice i nizovi: mnozenje kao elementwise i mnozenje kao mnozenje nad 
# objektima
# Matrice:
# Sve operacije nad nizovima i matricama su elementwise - mnozenje element sa 
# elementom, ukoliko se ne kaze drugacije; primer: mnozimo elemente istih
# indeksa u matricama a i aa:
aa * a
a * aa

# Ali ako hocu bas mnozenje matrica, kako smo ucili u matematici (matrice 
# gledamo kao objekte) onda se koristi funkcija dot(a, aa):
dot(a, aa)
dot(aa, a)
# u ovom primeru se mnoze matrica i njena inverzna matrica i dobija se 
# jedinicna matrica.


# Funkcija arange() i njena primena u nizovima
# Slicno kao i range(), ovde postoji funkcija arange(a, b, k) koja formira
# niz brojeva u opsegu [a, b] sa korakom k
x = arange(10)
print(x)
# mnozenje 2 niza - elementwise (kao i kod matrica)
x * x
# Skalarni proizvod dva niza
dot(x, x)



# Inicijalizacija matrica i nizova
# eye(N, M): vraca jedinicnu 2D matricu (na dijagonali jedinici a na svim 
# ostalim mestima nule); N je broj vrsta, M broj kolona; ako nema M smatra se 
# da je M=N
I = eye(3)
print(I)

# zeros((N, M)) - inicijalizacija niza ili matrice M x N sa svim nulama
zeros(4) 
zeros(3, 4)
# Paziti u slucaju inicijalizacije matrica, argument u zeros je tipa je tuple!
# Dakle, moraju se dodati unutrasnje zagrade, pa je ispravno pisati:
zeros((3, 4))
# moze i sa specifikacijom tipa, i tada se dodaje dtype;
# hocu da elementi budu tipa int
zeros((3, 4), dtype = int)
# ili npr. tipa complex
zeros((3, 4), dtype = complex)

# ones((M, N)) - inicijalizacija niza ili matrice M x N sa svim jeidinicama
ones(5)
ones((3, 4))
# inicijalizacija matrice M x N sa svim jeidinicama tipa int
ones((3, 4), dtype = int)


# empty((M, N)) - rezervacija prostora u memoriji za matricu MxN, sadrzaj je 
# slucajan; inicijalizacija sa slucajnim pocetnim vrednostima; ovo nemaju drugi 
# programski jezici
empty((3, 6))



# Jos neke elementwise operacije
a = array([[1,2], [3,4]])
print(a)
a + 1
a * a
a**3
a / 2



# Funkcija reshape() - daje novi oblik niza bez izmene njegovog sadrzaja 
help(reshape)
print(a)
reshape(a, (1, 4))
reshape(a, (4, 1))
# moze i kao OOP (a ne preko poziva funkcije kao primer iznad):
a.reshape(1, 4)
a.reshape(4, 1)
# a da li moze:
a.reshape(2, 3)
# Dakle, reshape() se ne moze uvek primeniti!



# 'in place' operacije sa nizovima i malo vezbanja 
xx = arange(20)
print(xx)
xx += 1
print(xx)
xx = xx.reshape(4, 5)
print(xx)
xx -= 1
print(xx)
xx *=  2
print(xx)



# Plotovanje (Matplotlib biblioteka, Pylab); vlastito ime modula je 
# matplotlib,pyplot pa bi alternativni import bio: 
# import matplotlib.pyplot as plt

# plot 1
x = arange(10) + 0.5
print(x)
y = x**2
print(y)
help(plot)
# prilikom crtanja x i y moraju biti istih dimenzija
# obratiti paznju da treba podesiti: 
# Tools->Preferences->IPython console->Graphics-> Graphic backend: Automatic
# da ne bi svaki put crtao novu sliku (opcija inline) vec jednu preko druge 
# dok mu mi sa figure() ne kazemo da otovri novu
figure()
# crta y versus x as lines (ako ne kazemo drugacije)
plot(x, y)
# crta isto ali sa podebljanom linijom
plot(x, y, linewidth=4)
# otvaramo sad novu sliku
figure()
# crta y versus x ali kao markere specificiranog oblika
# crveni plusici:
plot(x, y, 'r+')
# zeleni kruzici
plot(x, y, 'go')
# magenta dijamantici
plot(x, y, 'mD')
# zuti x-ici
plot(x, y, 'yx')
# a u novoj slici crveni kruzici povezani linijama
figure()
plot(x, y, 'ro-')

# sklanjamo sve slike
close('all')

# otvaramo novu sliku
figure()
plot(x, y) 
# oznacavanje x ose (naziv x ose)
xlabel('x')
# oznacavanje y ose (naziv y ose)
ylabel('y')
# naziv slike
title('y = x**2')

close('all')


# plot 2, zgodna funkcija u crtanju, linspace()
# linspace(start, stop, num) - ekvidistantna linearna podela izmedju start i 
# stop, u num tacaka
pp = linspace(1, 100, 10)
print(pp)
p = linspace(0, 100, 10)
print(p)
figure()
phi = linspace(0, 2 * pi, 1000)
plot(phi, sin(phi))
plot(phi, cos(phi))
# ubacujemo i legendu
legend(('sin', 'cos'))

# savefig('naziv') - snima sliku u radni folder, po definciji kao png, 
# ali moze i nesto drugo ako se specificira, npr. savefig('slika2.pdf)
savefig('slika')
savefig('slika2.pdf')
close('all')


#plot 3, xim() - granice po osama i xticks() - specificiranje podelaka
t = linspace(0, 10, 200)
figure()
plot(t, sin(t))
plot(t, cos(t))
xlabel('Vreme')
ylabel('Amplituda')
title('Signali')
legend(('sin', 'cos'))
# xlim i ylim definisu granice po osama u okviru kojih ce se prikazivati slika
xlim((0, 4))
# specificiranje podelaka na x osi
xticks(linspace(0, 4, 5))


# plot 4, axis() - promena osa
close('all')
figure()
phi = linspace(0, 2 * pi, 1000)
x = 2 * cos(phi)
y = 2 * sin(phi)
plot(x, y)
# axis omogucava promenu osa
axis([-3, 3, -3, 3])
# axis('equal) omogucava da prostor bude izotropan: jedinice po vertikali i 
# horizontali iste
axis('equal')
title('kruznica')


# plot 5, generator slucajnih brojeva i histogrami
close('all')
figure()
# rand(n) generise n slucajnih brojeva sa uniformnom raspodelom izmedju 0 i 1
x = rand(100)
plot(x)
# histogram, hist(x, num), x je slucajni broj a num broj binova histograma
figure()
hist(x, 10)


# plot 6, slucajni brojevi u normalnoj raspodeli
close('all')
figure()
# randn(n) generise n slucajnih brojeva u normalnoj raspodeli
x = randn(1000)
plot(x)
# preko histograma
figure()
hist(x, 100)


# plot 7, subplot i stem
close('all')
figure()
t = linspace(0, 20, 200)
# delimo sliku za vise prikaza na istoj slici
subplot(2, 1, 1)
plot(t, sin(t))
k = linspace(0, 20, 40)
# moze i preko k = arange(0, 20, 0.5) umesto ovog linspace
subplot(2, 1, 2)
# stem plot - za svako x crta vertikalne linije duzine y i postavlja na tu 
# tacku marker
stem(k, sin(k))
